<?php

function jkof_import_url_file(){
    $import_url   =    secure($_POST['import_url']);

    if(!filter_var($import_url, FILTER_VALIDATE_URL)){
        die("INVALID_URL");
    }

    $new_name                =    explode("/", $import_url);
    $new_name                =    $new_name[count($new_name)-1];
    $new_name                =    str_replace('"', '', $new_name);
    $new_name                =    str_replace("'", '', $new_name);
    $disallowed_files        =    array(".htaccess","php.ini",".htpasswd");

    if(in_array($new_name, $disallowed_files)){
        die("ERROR");
    }

    if( file_exists( OF_DIR . "raw/" . $new_name ) ){
        $new_name            =    get_random_string( mt_rand( 6, 16 ) ) . "_" . $new_name;
    }

    if( file_put_contents( OF_DIR . "raw/" . $new_name, fopen($import_url, 'r')) ){
        $finfo                   =    finfo_open(FILEINFO_MIME_TYPE);
        $file_type               =    finfo_file($finfo, OF_DIR . "raw/" . $new_name);
        finfo_close($finfo);
        $filesize                =    filesize(OF_DIR . "raw/" . $new_name);

        $resArr    =    array(
            "new_name"    =>    $new_name,
            "size"        =>    $filesize,
            "type"        =>    $file_type
        );

        echo json_encode($resArr);
    }

    die();
}