<?php

function jkof_get_idl_links(){
    global $wpdb;

    $fid                 =    sanitize_text_field($_POST['fid']);
    $file_settings       =    get_post_meta( $fid, 'jkof_dl_settings', true );

    if(empty($file_settings)){
        die("No Files Found");
    }

    echo '<a href="?ofdl=' . $fid . '&idl=all" class="rcw-small rcw-button-3 turquoise btn-full-block">
    <span class="button-icon fa fa-download"></span> Download All Files</a>';
    
    $file_list     =    (isset($file_settings['files'])) ? $file_settings['files'] : array();
    foreach( $file_list as $file_key => $file_value ){
        $fileObj    =    json_decode($file_value);
        $fileTitle  =    ($fileObj->isDirect == 1) ? "Download " . $fileObj->name: "Go to File";
        $fileURL    =    ($fileObj->isDirect == 1) ? "?ofdl=" . $fid . "&fkey=" . $file_key: $fileObj->direct_url;
?>
<a href="<?php echo $fileURL; ?>" class="rcw-small rcw-button-3 wetasphalt btn-full-block">
    <span class="button-icon fa fa-download"></span>
    <?php echo $fileTitle; ?>
</a>
<?php
    }
    die();
}