jQuery(function($){
    $(document).on("click", ".jkof_openDLModalBtn", function(e){
        e.preventDefault();

        var btnFID  =   $(this).attr("data-fid");
        $("#jkof-dl-modal").attr( "data-fid", $(this).attr("data-fid") ); // Set File ID

        // Determine Locks
        var modalLocks    =    $(this).attr('data-locks').split(",");
        if($.inArray("1",modalLocks) > -1){
            $(".jkof-pw-btn").show();
        }else{
            $(".jkof-pw-btn").hide();
        }

        if($.inArray("2",modalLocks) > -1){
            $(".jkof-li-btn").show();
        }else{
            $(".jkof-li-btn").hide();
        }

        if($.inArray("3",modalLocks) > -1){
            $(".jkof-fb-share-btn").show();
        }else{
            $(".jkof-fb-share-btn").hide();
        }

        if($.inArray("4",modalLocks) > -1){
            $(".jkof-fb-like-btn").show();
        }else{
            $(".jkof-fb-like-btn").hide();
        }

        if($.inArray("5",modalLocks) > -1){
            $(".jkof-t-follow-btn").show();
        }else{
            $(".jkof-t-follow-btn").hide();
        }

        if($.inArray("6",modalLocks) > -1){
            $(".jkof-t-tweet-btn").show();
        }else{
            $(".jkof-t-tweet-btn").hide();
        }

        if($.inArray("7",modalLocks) > -1){
            $(".jkof-gp-plus-btn").show();
        }else{
            $(".jkof-gp-plus-btn").hide();
        }

        if($.inArray("8",modalLocks) > -1){
            $(".jkof-email-btn").show();
        }else{
            $(".jkof-email-btn").hide();
        }

        if($.inArray("9",modalLocks) > -1){
            $(".jkof-pp-btn").show();
        }else{
            $(".jkof-pp-btn").hide();
        }

        $(".jkof-idl-ctr").hide();

        if(modalLocks[0] === ""){
            console.log(modalLocks);
            $(".jkof-main-ctr").fadeOut(function(){
                $(".jkof-idl-ctr").fadeIn();
                jkof_getIndividualDownloads(btnFID);
            });
        }


        // Setup Modal
        $("#jkof-dl-modal").attr('data-li-message', $(this).attr('data-li-message'));
        var liURL    =    ($(this).attr('data-li-url') === "") ? window.location.href : $(this).attr('data-li-url');
        $("#jkof-dl-modal").attr('data-li-url', liURL);
        $("#jkof_inputPPReturnURL").val(window.location.href);
        $("#jkof_inputPPItemName").val( $(this).attr('data-item-name') );
        $("#jkof_inputPPfid").val( $(this).attr('data-fid') );
        $("#jkof-dl-modal").attr("data-allow-idl", $(this).attr("data-allow-idl"));
        var fbLikeURL    =    ($(this).attr('data-fb-like-url') === "") ? window.location.href : $(this).attr('data-fb-like-url');
        $("#jkof_fbDLLikeBtn").attr('data-href', fbLikeURL);
        $("#jkof_inputPPAmount").val( $(this).attr('data-pp-amount') );
        $("#jkof_tweetBtnCtr").html(
            '<a class="twitter-share-button" href="https://twitter.com/share"' + 
            'data-related="twitterdev" data-size="large" data-count="none" data-via="' + 
            $("#jkof-dl-modal").attr("data-twitter-username") + '"' +
            'data-text="' + $(this).attr("data-tweet") + '"> Tweet</a>'
        );
        var gplus_url    =     ($(this).attr('data-gplus-url') === "") ? window.location.href : $(this).attr('data-gplus-url');
        $("#jkof_gPlusOneCtr").html(
            '<div id="jkof_gPlusOneBtn""></div>'
        );
        gapi.plusone.render("jkof_gPlusOneBtn",{
            size: "tall",
            onstartinteraction: "jkof_gplus_download_file",
            href: gplus_url
        });
        twttr.widgets.load();  //very important
        twttr.events.bind(
            'tweet',
            function (event) {
                console.log(event);
                if($("#jkof-dl-modal").attr("data-allow-idl") == 2){
                    $(".jkof-t-tweet-ctr").fadeOut(function(){
                        $(".jkof-idl-ctr").fadeIn();
                        jkof_getIndividualDownloads($("#jkof-dl-modal").attr('data-fid'));
                    });
                }else{
                    location.href    =    "?ofdl=" + $("#jkof-dl-modal").attr('data-fid') + "&t_tweet=true";
                }
            }
        );
    });

    $(".jkof-pw-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(".jkof-password-ctr").fadeIn();
        });
    });

    $(".jkof-li-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(".jkof-linkedin-ctr").fadeIn();
        });
    });

    $(".jkof-fb-share-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(".jkof-fb-share-ctr").fadeIn();
        });
    });

    $(".jkof-fb-like-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(".jkof-fb-like-ctr").fadeIn();
        });
    });

    $(".jkof-t-follow-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(".jkof-t-follow-ctr").fadeIn();
        });
    });

    $(".jkof-t-tweet-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(this).parent().parent().find(".jkof-t-tweet-ctr").fadeIn();
        });
    });

    $(".jkof-gp-plus-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(".jkof-gp-plus-ctr").fadeIn();
        });
    });

    $(".jkof-email-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(".jkof-email-ctr").fadeIn();
        });
    });

    $(".jkof-pp-btn").click(function(e){
        e.preventDefault();
        $(this).parent().fadeOut(function(){
            $(this).parent().parent().find(".jkof-pp-ctr").fadeIn();
        });
    });

    $(document).on('click', ".jkof_goBackBtn", function(e){
        e.preventDefault();
        $(".jkof_goBackBtn").parent().fadeOut( 'fast', function(){
            $("#jkof-dl-modal").find(".jkof-main-ctr").fadeIn('fast');
        });
    });

    $("#jkof_passwordForm").submit(function(e){
        e.preventDefault();

        $("#jkof_passwordForm").slideUp('fast', function(){
            $("#jkof-dl-modal").find(".jkof_password_status_placeholder").html(
                '<div class="jkof_status_ctr jkof_status_info">' +
                '<h4><strong>Please wait!</strong></h4><p>We are checking this password.</p>' +
                '</div>'
            ).hide().slideDown('fast');

            var formObj    =    {
                password:    $("#jkof_inputPassword").val(),
                action:      'jkof_check_password',
                fid:         $("#jkof-dl-modal").attr("data-fid")
            };

            $.post( jkof_ajax_url, formObj, function(data){
                if(data == "SUCCESS"){
                    $("#jkof-dl-modal").find(".jkof_password_status_placeholder").html(
                        '<div class="jkof_status_ctr jkof_status_success">' +
                        '<h4><strong>Success!</strong></h4><p>Your download will begin in a moment.</p>' +
                        '</div>'
                    );
                    if($("#jkof-dl-modal").attr("data-allow-idl") == 2){
                        $(".jkof-password-ctr").fadeOut(function(){
                            $(".jkof-idl-ctr").fadeIn();
                            jkof_getIndividualDownloads($("#jkof-dl-modal").attr('data-fid'));
                        });
                    }else{
                        $("#jkof_passwordForm").slideDown('fast');
                        location.href    =    "?ofdl=" + formObj.fid;
                    }
                }else{
                    $("#jkof-dl-modal").find(".jkof_password_status_placeholder").html(
                        '<div class="jkof_status_ctr jkof_status_danger">' +
                        '<h4><strong>Access Denied!</strong></h4><p>' + data + '.</p>' +
                        '</div>'
                    );
                    $("#jkof_passwordForm").slideDown('fast');
                }
            });
        });
    });

    window.fbAsyncInit = function() {
        FB.init({
            appId      : jkof_fb_app_id,
            xfbml      : true,
            version    : 'v2.2'
        });

        FB.Event.subscribe('edge.create', function(url, html_element){
            if($("#jkof-dl-modal").attr("data-allow-idl") == 2){
                $(".jkof-fb-like-ctr").fadeOut(function(){
                    $(".jkof-idl-ctr").fadeIn();
                    jkof_getIndividualDownloads($("#jkof-dl-modal").attr('data-fid'));
                });
            }else{
                window.location.href    =    "?ofdl=" + $("#jkof-dl-modal").attr('data-fid') + "&fb_like=true";
            }
        });
    };

    $(".jkofFBShareLockBtn").click(function(e){
        e.preventDefault();
        FB.ui({
            method: 'share',
            href: window.location.href
        }, function(response){
            if(typeof response != "undefined"){
                if($("#jkof-dl-modal").attr("data-allow-idl") == 2){
                    $(".jkof-fb-share-ctr").fadeOut(function(){
                        $(".jkof-idl-ctr").fadeIn();
                        jkof_getIndividualDownloads($("#jkof-dl-modal").attr('data-fid'));
                    });
                }else{
                    location.href    =    "?ofdl=" + $("#jkof-dl-modal").attr('data-fid') + "&fb_share=true";
                }
            }
        });
    });

    window.twttr=(function(d,s,id){var t,js,fjs=d.getElementsByTagName(s)[0];if(d.getElementById(id)){return}js=d.createElement(s);js.id=id;js.src="https://platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);return window.twttr||(t={_e:[],ready:function(f){t._e.push(f)}})}(document,"script","twitter-wjs"));

    twttr.ready(
        function (twttr) {
            twttr.events.bind(
                'follow',
                function (event) {
                    var followedUserId = event.data.user_id;
                    var followedScreenName = event.data.screen_name;
                    if($("#jkof-dl-modal").attr("data-allow-idl") == 2){
                        $(".jkof-t-follow-ctr").fadeOut(function(){
                            $(".jkof-idl-ctr").fadeIn();
                            jkof_getIndividualDownloads($("#jkof-dl-modal").attr('data-fid'));
                        });
                    }else{
                        location.href    =    "?ofdl=" + $("#jkof-dl-modal").attr('data-fid') + "&t_follow=true";
                    }
                }
            );
        }
    );

    $("#jkof_emailDLForm").submit(function(e){
        e.preventDefault();

        $("#jkof_emailDLForm").slideUp('fast', function(){
            $("#jkof-dl-modal").find(".jkof_email_status_placeholder").html(
                '<div class="jkof_status_ctr jkof_status_info">' +
                '<h4><strong>Please wait!</strong></h4><p>We are adding your e-mail.</p>' +
                '</div>'
            ).hide().slideDown('fast');

            var formObj    =    {
                email:       $("#jkof_inputEmail").val(),
                action:      'jkof_check_email',
                fid:         $("#jkof-dl-modal").attr("data-fid")
            };

            $.post( jkof_ajax_url, formObj, function(data){
                if(data == "SUCCESS_INSTANT"){
                    $("#jkof-dl-modal").find(".jkof_email_status_placeholder").html(
                        '<div class="jkof_status_ctr jkof_status_success">' +
                        '<h4><strong>Success!</strong></h4><p>Your download will begin in a moment.</p>' +
                        '</div>'
                    );
                    if($("#jkof-dl-modal").attr("data-allow-idl") == 2){
                        $(".jkof-email-ctr").fadeOut(function(){
                            $(".jkof-idl-ctr").fadeIn();
                            jkof_getIndividualDownloads($("#jkof-dl-modal").attr('data-fid'));
                        });
                    }else{
                        location.href    =    "?ofdl=" + $("#jkof-dl-modal").attr('data-fid') + "&edl=true";
                    }
                    $("#jkof_emailDLForm").slideDown('fast');
                }else if(data == "SUCCESS_EMAIL"){
                    $("#jkof-dl-modal").find(".jkof_email_status_placeholder").html(
                        '<div class="jkof_status_ctr jkof_status_success">' +
                        '<h4><strong>Success!</strong></h4><p>We have e-mailed your download.</p>' +
                        '</div>'
                    );
                    console.log("email sent");
                    $("#jkof_emailDLForm").slideDown('fast');
                }else{
                    $("#jkof-dl-modal").find(".jkof_email_status_placeholder").html(
                        '<div class="jkof_status_ctr jkof_status_danger">' +
                        '<h4><strong>Access Denied!</strong></h4><p>' + data + '</p>' +
                        '</div>'
                    );
                    $("#jkof_emailDLForm").slideDown('fast');
                    console.log(data);
                }
            });
        });
    });

    $("#jkof-dl-modal").on('hidden.bs.modal', function (e) {
        $(".jkof-main-ctr").show();
        $(".jkof-password-ctr").hide();
        $(".jkof-linkedin-ctr").hide();
        $(".jkof-fb-share-ctr").hide();
        $(".jkof-fb-like-ctr").hide();
        $(".jkof-t-follow-ctr").hide();
        $(".jkof-t-tweet-ctr").hide();
        $(".jkof-gp-plus-ctr").hide();
        $(".jkof-email-ctr").hide();
        $(".jkof-pp-ctr").hide();

        // Password
        $(".jkof_password_status_placeholder").hide();
        $(".jkof_passwordForm").show();
        $("#jkof_inputPassword").val('');

        // LinkedIn
        $(".jkof_linkedin_status_placeholder").hide();

        // Facebook Share
    });
});

function onLinkedInLoad() {
    IN.Event.on(IN, "auth", function() {onLinkedInLogin();});
    IN.Event.on(IN, "logout", function() {onLinkedInLogout();});
}

function onLinkedInLogout() {
    // do nothing
}

function onLinkedInLogin() {
    jQuery(document).on('click', ".jkofLinkedInLockBtn", function(e){
        e.preventDefault();
        jQuery("#jkof-dl-modal").find(".jkof_linkedin_status_placeholder").html(
            '<div class="jkof_status_ctr jkof_status_info">' +
            '<h4><strong>Please wait!</strong></h4><p>We are adding this message to your wall</p>' +
            '</div>'
        );
        doSharingTest();
    });
}

function doSharingTest() {
    IN.API.Raw("/people/~/shares")
    .method("POST")
    .body( JSON.stringify( {
        "content": {
            "submitted-url": jQuery("#jkof-dl-modal").attr('data-li-url'),
            "title": document.title,
            "description": document.title,
            "submitted-image-url": getFavicon()
        },
        "visibility": {
            "code": "anyone"
        },
        "comment": jQuery("#jkof-dl-modal").attr('data-li-message')
    }))
    .result(function(r) {
        if(jQuery("#jkof-dl-modal").attr("data-allow-idl") == 2){
            jQuery(".jkof-linkedin-ctr").fadeOut(function(){
                jQuery(".jkof-idl-ctr").fadeIn();
                jkof_getIndividualDownloads(jQuery("#jkof-dl-modal").attr('data-fid'));
            });
        }else{
            jQuery("#jkof-dl-modal").find(".jkof_linkedin_status_placeholder").html(
                '<div class="jkof_status_ctr jkof_status_success">' +
                '<h4><strong>Success!</strong></h4><p>Your download will begin in a moment</p>' +
                '</div>'
            );
            location.href    =    "?ofdl=" + jQuery("#jkof-dl-modal").attr("data-fid") + "&li_share=true";
        }
    })
    .error(function(r) {
        console.log(r);
        jQuery("#jkof-dl-modal").find(".jkof_linkedin_status_placeholder").html(
            '<div class="jkof_status_ctr jkof_status_danger">' +
            '<h4><strong>Uh Oh!</strong></h4><p>We could not share this message on LinkedIn.</p>' +
            '</div>'
        );
    });
}
var getFavicon = function(){
    var favicon = undefined;
    var nodeList = document.getElementsByTagName("link");
    for (var i = 0; i < nodeList.length; i++)
    {
        if((nodeList[i].getAttribute("rel") == "icon")||(nodeList[i].getAttribute("rel") == "shortcut icon"))
        {
            favicon = nodeList[i].getAttribute("href");
        }
    }
    return favicon;
};
function jkof_gplus_download_file(jsonParam){
    if(jsonParam.type == "confirm"){
        if(jQuery("#jkof-dl-modal").attr("data-allow-idl") == 2){
            jQuery(".jkof-gp-plus-ctr").fadeOut(function(){
                jQuery(".jkof-idl-ctr").fadeIn();
                jkof_getIndividualDownloads(jQuery("#jkof-dl-modal").attr('data-fid'));
            });
        }else{
            location.href    =    "?ofdl=" + jQuery("#jkof-dl-modal").attr('data-fid') + "&gplus=true";
        }
    }
}
function jkof_getIndividualDownloads( fid ){
    var formObj    =    {
        action:      'jkof_get_idl_links',
        fid:         fid
    };
    jQuery.post( jkof_ajax_url, formObj, function(data){
        jQuery(".jkof-idl-ctr").html(data);
    });
}