<?php

function jkof_add_browser_file(){
    $file    =    secure($_POST['file']);

    $new_name                =    explode("/", $file);
    $new_name                =    $new_name[count($new_name)-1];
    $new_name                =    str_replace('"', '', $new_name);
    $new_name                =    str_replace("'", '', $new_name);
    $disallowed_files        =    array(".htaccess","php.ini",".htpasswd");
    $finfo                   =    finfo_open(FILEINFO_MIME_TYPE);
    $file_type               =    finfo_file($finfo, $file);
    finfo_close($finfo);
    $filesize                =    filesize($file);

    if(in_array($new_name, $disallowed_files)){
        die("ERROR");
    }

    if( file_exists( OF_DIR . "raw/" . $new_name ) ){
        $new_name            =    get_random_string( mt_rand( 6, 16 ) ) . "_" . $new_name;
    }

    if( copy( $file, OF_DIR . "raw/" . $new_name ) ){
        $resArr    =    array(
            "new_name"    =>    $new_name,
            "size"        =>    $filesize,
            "type"        =>    $file_type
        );
        
        echo json_encode($resArr);
    }

    die();
}