<?php

function jkof_delete_emails(){
    if(!current_user_can("manage_options")){
        die("ACTION_DENIED");
        return;
    }
    
    global $wpdb;

    foreach($_POST['emails'] as $eid){
        $wpdb->delete( $wpdb->prefix . 'of_emails', array( 'id' => $eid ), array( '%d' ) );
    }

    die();
}

function jkof_export_selected_emails(){
    global $wpdb;
    $email_list    =    array();

    foreach($_POST['emails'] as $eid){
        $email = $wpdb->get_row("SELECT `email` FROM " . $wpdb->prefix . "of_emails WHERE id=" . intval($eid));
        array_push($email_list, $email->email);
    }

    $handle = fopen("emails.csv", "w");
    fwrite($handle, implode(",", $email_list));
    fclose($handle);

    die();
}

function jkof_export_all_emails(){
    global $wpdb;
    $email_list    =    array();
    $of_emails    =    $wpdb->get_results("SELECT `email` FROM " . $wpdb->prefix . "of_emails");
    foreach($of_emails as $of_email){
        array_push($email_list, $of_email->email);
    }

    $handle = fopen("emails.csv", "w");
    fwrite($handle, implode(",", $email_list));
    fclose($handle);

    die();
}

function jkof_export_unique_emails(){
    global $wpdb;
    $email_list    =    array();
    $of_emails    =    $wpdb->get_results("SELECT DISTINCT `email` FROM " . $wpdb->prefix . "of_emails");
    foreach($of_emails as $of_email){
        array_push($email_list, $of_email->email);
    }

    $handle = fopen("emails.csv", "w");
    fwrite($handle, implode(",", $email_list));
    fclose($handle);

    die();
}