<?php

function jkof_create_dl_modal(){
    $jkof_settings    =    get_option( 'jkof_settings' );
    if(!empty($jkof_settings['social_settings']['li_api_key']))
    {
?>
<script type="text/javascript" src="http://platform.linkedin.com/in.js">
    api_key: <?php echo $jkof_settings['social_settings']['li_api_key']; ?>

    authorize: true
    onLoad: onLinkedInLoad
</script>
<?php
    }
    if(!empty($jkof_settings['social_settings']['fb_app_id']))
    {
?>    
<script>
    (function(d, s, id){
        var js, fjs = d.getElementsByTagName(s)[0];
        if (d.getElementById(id)) {return;}
        js = d.createElement(s); js.id = id;
        js.src = "//connect.facebook.net/en_US/sdk.js";
        fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));
    jkof_fb_app_id   =    '<?php echo $jkof_settings['social_settings']['fb_app_id']; ?>';
</script>
<?php
    }
?>
<script src="https://apis.google.com/js/platform.js" async defer></script>
<script>
    jkof_ajax_url    =    '<?php echo admin_url('admin-ajax.php');?>';
</script>
<!-- Modal -->
<div class="modal fade" id="jkof-dl-modal" tabindex="-1" role="dialog" aria-hidden="true" data-backdrop="static"
     data-fid="" data-li-message="" data-li-url="" aria-labelledby="myModalLabel" data-allow-idl="1"
     data-twitter-username="<?php echo $jkof_settings['social_settings']['twitter_u']; ?>">
    <div class="modal-dialog" style="margin-top:50px;">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" style="position: absolute;right: 15px;">
                    <span aria-hidden="true">&times;</span>
                </button>
                <h4 class="modal-title" id="myModalLabel" style="margin:0;">Download File</h4>
            </div>
            <div class="modal-body">
                <div class="jkof-main-ctr">
                    <p class="text-center">
                        If you would like to download this file, then you will have to unlock it by
                        clicking one of the options below.
                    </p>
                    <button type="button" class="nephritis rcw-medium rcw-button-5 btn-full-block jkof-pw-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-lock"></span> Unlock with password
                    </button>
                    <button type="button" class="facebook rcw-medium rcw-button-5 btn-full-block jkof-fb-share-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-facebook"></span> Share on Facebook
                    </button>
                    <button type="button" class="facebook rcw-medium rcw-button-5 btn-full-block jkof-fb-like-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-facebook"></span> Like us
                    </button>
                    <button type="button" class="rcw-medium rcw-button-5 linkedin btn-full-block jkof-li-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-linkedin"></span> Share on LinkedIn
                    </button>
                    <button type="button" class="rcw-medium rcw-button-5 twitter btn-full-block jkof-t-follow-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-twitter"></span> Follow us on Twitter
                    </button>
                    <button type="button" class="rcw-medium rcw-button-5 twitter btn-full-block jkof-t-tweet-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-twitter"></span> Tweet us on Twitter
                    </button>
                    <button type="button" class="rcw-medium rcw-button-5 googleplus btn-full-block jkof-gp-plus-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-google-plus"></span> +1 on Google Plus
                    </button>
                    <button type="button"class="rcw-medium rcw-button-5 purple btn-full-block jkof-email-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-envelope"></span> Unlock with your e-mail
                    </button>
                    <button type="button" class="rcw-medium rcw-button-5 paypal btn-full-block jkof-pp-btn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-paypal"></span> Purchase with Paypal
                    </button>
                </div>
                <div class="jkof-password-ctr" style="display:none;">
                    <div class="jkof_password_status_placeholder" style="display:none;"></div>
                    <form id="jkof_passwordForm">
                        <p class="text-center">Enter the password to download this file.</p>
                        <input type="password" id="jkof_inputPassword" placeholder="Enter Password">
                        <button type="submit" class="greensea rcw-small rcw-button-7 btn-full-block">
                            <span class="icon-bg"></span><span class="button-icon fa fa-download"></span> Download File
                        </button>
                    </form>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-linkedin-ctr" style="display:none;">
                    <div class="jkof_linkedin_status_placeholder"></div>
                    <p style="margin-bottom: 10px;">Share a message on LinkedIn to download this file!</p>
                    <script type="in/Login">
                    <button type="button" class="rcw-medium rcw-button-7 linkedin btn-full-block jkofLinkedInLockBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-linkedin"></span> Share and Download File
                        </button>
                    </script>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-fb-share-ctr" style="display:none;">
                    <p>Share a message on Facebook to download this file!</p>
                    <button type="button" class="facebook rcw-medium rcw-button-7 btn-full-block jkofFBShareLockBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-facebook"></span> Share and Download File
                    </button>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-fb-like-ctr" style="display:none;">
                    <p>Like this page on Facebook to download this file!</p>
                    <div class="fb-like" style="margin-top: 10px; margin-bottom: 10px;"
                         data-href="" id="jkof_fbDLLikeBtn" 
                         data-layout="standard" data-action="like" data-show-faces="false" data-share="false"></div>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-t-follow-ctr" style="display:none;">
                    <p style="margin-bottom:10px;">Follow us on twitter to download this file!</p>
                    <a href="https://twitter.com/<?php echo $jkof_settings['social_settings']['twitter_u']; ?>" 
                       class="twitter-follow-button" data-show-count="false" data-size="large">
                        Follow @<?php echo $jkof_settings['social_settings']['twitter_u']; ?>
                    </a>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-t-tweet-ctr" style="display:none;">
                    <p style="margin-bottom: 10px;">Tweet us on twitter!</p>
                    <div id="jkof_tweetBtnCtr"></div>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-gp-plus-ctr" style="display:none;">
                    <p style="margin-bottom: 10px;">+1 us on Google Plus</p>
                    <div id="jkof_gPlusOneCtr"></div>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-email-ctr" style="display:none;">
                    <div class="jkof_email_status_placeholder" style="display:none;"></div>
                    <form id="jkof_emailDLForm">
                        <p class="text-center">Enter your email to download this file!</p>
                        <input type="email" id="jkof_inputEmail" placeholder="Enter E-mail">
                        <button type="submit" class="purple rcw-medium rcw-button-7 btn-full-block">
                            <span class="icon-bg"></span><span class="button-icon fa fa-envelope"></span> Submit & Download File
                        </button>
                    </form>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-pp-ctr" style="display:none;">
                    <p>Purchase with paypal for</p>
                    <p style="margin: 10px 0;font-size:24px;" id="jkof_ppDisplayPrice">$</p>
                    <p style="color:red;margin-bottom:10px;">
                        <strong>The download link will be e-mailed to your paypal e-mail.</strong>
                    </p>
                    <form action="https://www.paypal.com/cgi-bin/webscr" method="post">
                        <input type="hidden" name="cmd" value="_xclick">
                        <input type="hidden" name="custom" value="jkof_pp">
                        <input type="hidden" name="charset" value="utf-8">
                        <input type="hidden" name="return" id="jkof_inputPPReturnURL">
                        <input type="hidden" name="currency_code" value="USD">
                        <input type="hidden" name="business" value="<?php echo $jkof_settings['pp_settings']['email']; ?>">
                        <input type="hidden" name="item_name" id="jkof_inputPPItemName">
                        <input type="hidden" name="item_number" id="jkof_inputPPfid">
                        <input type="hidden" name="amount" id="jkof_inputPPAmount">
                        <input type="hidden" name="quantity" value="1">
                        <input type="image" src="https://www.paypalobjects.com/webstatic/en_US/btn/btn_checkout_pp_142x27.png"
                               border="0" alt="Submit">
                    </form>
                    <button type="button" class="silver rcw-small rcw-button-7 btn-full-block jkof_goBackBtn">
                        <span class="icon-bg"></span><span class="button-icon fa fa-arrow-left"></span> Go Back
                    </button>
                </div>
                <div class="text-center jkof-idl-ctr" style="display:none;">
                    <p style="font-size:64px;"><i class="fa fa-spinner fa-spin"></i></p>
                    <p>Getting Downloads...</p>
                </div>
            </div>
        </div>
    </div>
</div>
<?php
}