<?php

function jkof_create_post_type(){
    $labels = array(
        'name'               => __( 'Onyx Files' ),
        'singular_name'      => __( 'Onyx File' ),
        'add_new'            => __( 'Add New' ),
        'add_new_item'       => __( 'Add New Onyx File' ),
        'edit_item'          => __( 'Edit Onyx File' ),
        'new_item'           => __( 'New Onyx File' ),
        'all_items'          => __( 'All Onyx Files' ),
        'view_item'          => __( 'View Onyx File' ),
        'search_items'       => __( 'Search Onyx File' ),
        'not_found'          => __( 'No Onyx Files found' ),
        'not_found_in_trash' => __( 'No Onyx Files found in the Trash' ), 
        'parent_item_colon'  => '',
        'menu_name'          => 'Onyx Files'
    );
    $args = array(
        'labels'        => $labels,
        'description'   => 'Holds the onyx files and their data.',
        'public'        => trye,
        'menu_position' => 5,
        'supports'      => array( 'title', 'editor', 'comments', 'thumbnail' ),
        'has_archive'   => true,
        'show_ui'       => true,
        'taxonomies'    => array('category', 'post_tag'),
        'menu_icon'     => 'dashicons-cloud'
    );
    register_post_type( 'of_files', $args ); 
}

function add_new_of_columns($gallery_columns) {
    $new_columns['cb'] = '<input type="checkbox" />';
    //$new_columns['id'] = __('ID');
    $new_columns['title'] = _x('Download Name', 'column name');
    //$new_columns['images'] = __('Images');
    //$new_columns['author'] = __('Author');
    //$new_columns['categories'] = __('Categories');
    $new_columns['shortcode'] = __('Shortcode');
    $new_columns['downloads'] = __('Downloads');
    $new_columns['views'] = __('Views');
    $new_columns['earnings'] = __('Earnings');
    $new_columns['date'] = _x('Date', 'column name');

    return $new_columns;
}

function manage_of_columns($column_name, $id) {
    switch ($column_name) {
        case 'shortcode':
            echo "<input type='text' readonly value='[onyxfile id=" . $id . "]'>";
            break;
        case 'downloads':
            $file_settings    =    get_post_meta( $id, 'jkof_dl_settings', true );
            echo $file_settings['dl_count'];
            break;
        case 'views':
            $file_settings    =    get_post_meta( $id, 'jkof_dl_settings', true );
            echo $file_settings['view_count'];
            break;
        case 'earnings':
            $file_settings    =    get_post_meta( $id, 'jkof_dl_settings', true );
            echo "$";
            echo (isset($file_settings['earnings'])) ? $file_settings['earnings'] : "0.00";
            break;
        default:
            break;
    } // end switch
}